#  V820.defn.tcl

proc {Add_CAEN V820_Module} {name server addressdata} {
   global CurrentVMEServer

   set moduleID [last [split $name #]]

#    split up address information into 
   set addressinfo [split $addressdata :]
   set A16addrbase [first $addressinfo]
   set A24addrbase [second $addressinfo]
   set A32addrbase [third $addressinfo]

   set CurrentVMEServer  $server

   for {set i 0} {$i < 32} {incr i} {
      define-vme-register $name xVME Counter$i        "-a$A32addrbase -w32 -o[expr 0x1000+($i*4)] -pro -d32 -l0 -b0 -zd"
   }
 
   define-vme-register $name xVME Dwell               "-a$A32addrbase -w32 -o0x1104 -prw -d32 -l0 -b0 -zx -i0"
   define-vme-register $name xVME CR                  "-a$A32addrbase -w32 -o0x1108 -prw -d16 -l0 -b0 -zx"
   define-vme-register $name xVME Mode                "-a$A32addrbase -w32 -o0x1108 -prw -d16 -l2 -b0 -zd"
   define-vme-register $name xVME SR                  "-a$A32addrbase -w32 -o0x110e -pro -d16 -l0 -b0 -zd"
   define-vme-register $name xVME Clear               "-a$A32addrbase -w32 -o0x1122 -pwo -d16 -l0 -b0 -i0"
   define-vme-register $name xVME Trig                "-a$A32addrbase -w32 -o0x1124 -pwo -d16 -l0 -b0"

   define-vme-register $name xVME ModID#1              "-a$A32addrbase -w32 -o0x8026 -pro -d16 -l0 -b0 -zx"
   define-vme-register $name xVME ModID#2              "-a$A32addrbase -w32 -o0x802a -pro -d16 -l0 -b0 -zx"
   define-vme-register $name xVME ModID#3              "-a$A32addrbase -w32 -o0x802e -pro -d16 -l0 -b0 -zx"
}


proc {CAEN V820_DAQ-reset} {args} {
#   V820
    global CurrentVMEServer EGallow
    set server [second $args]
    if {$server != ""} then {set CurrentVMEServer $server}
    set module [first $args]

#      perform simple module access - if a bus error occurs then generate warning
    set EGallow 0x2000a
    if {[read-vme-register $module.ModID#1] == $EGallow} then {bus-error $module; set EGallow 0xffffffff; return}
    set EGallow 0xffffffff
}

proc {CAEN V820_DAQ-flush} {args} {
#   V820
    global CurrentVMEServer EGallow
    set server [second $args]
    if {$server != ""} then {set CurrentVMEServer $server}
    set module [first $args]
}

proc {CAEN V820_DAQ-go} {args} {
#   V820
    global CurrentVMEServer
    set server [second $args]
    if {$server != ""} then {set CurrentVMEServer $server}
    set module [first $args]
    write-vme-register $module.Clear 0
}

proc {CAEN V820_DAQ-halt} {args} {
#   V820
    global CurrentVMEServer
    set server [second $args]
    if {$server != ""} then {set CurrentVMEServer $server}
    set module [first $args]
}

proc {CAEN V820_DAQ-setup} {args} {
#   V820
    global CurrentVMEServer 
    set server [second $args]
    if {$server != ""} then {set CurrentVMEServer $server}
    set module [first $args]
    initialise-vme-registers $module.*
}

#   for parameter save/restore
set {CAEN V820_registersavepatterns} {CR Dwell}


